package org.hso.ecommerce.app;

import org.hso.ecommerce.objects.User;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletResponse;
import java.util.UUID;

@Controller
public class RequestController {

    @GetMapping("/")
    public String greeting() {
        return "redirect:/home";
    }

    @GetMapping("/home")
    public String home(Model model) {
        model.addAttribute(new User());
        return "home";
    }

    @GetMapping("/greeting")
    public String greeting(@RequestParam(name = "name", required = false, defaultValue = "World") String name, Model model) {
        model.addAttribute("name", name);
        return "greeting";
    }

    @RequestMapping(value="/home", method=RequestMethod.POST, params="action=login")
    public String login(@ModelAttribute User user, HttpServletResponse response) {
        // do the login magic and get a loginToken
        System.out.println(user.getUname());
        System.out.println(user.getPwd());

        String loginToken = UUID.randomUUID().toString();

        // set the loginToken as session cookie
        Cookie cookie = new Cookie("loginToken", loginToken);
        response.addCookie(cookie);
        return "redirect:/home";
    }

    @RequestMapping("/register")
    public String register(@CookieValue(value = "loginToken", defaultValue = "") String loginToken) {
        System.out.println(loginToken);
        return "register";
    }

}
